#!/usr/bin/perl -w
#my $Id = '$Id: cp_auto_gen.pl 4467 2011-01-19 23:57:05Z pro $';
#usage cp_auto_gen.pl ..\doc\doc.txt
use lib '../lib';
use psmisc;
#use '..\lib\psmisc.pm';
#require '..\confdef.pl';
psmisc::config();
$config{'cp_learn_symbols'}  = 20;
$config{'cp_learn_print_cp'} = 'cp1251';
#my @dep = qw(win utf dos koi iso);    #deprecated
my %s;
my $sc;

=make pure words
for (<>) {
  $_ = psmisc::html_strip($_);
  s{&\w+;}{}g;
  my $cp = psmisc::cp_detect_trans( \$_, undef, 'win', );
  ++$words{$_} for grep { /[--]/ } split /\W+/, $_;
}
print join ' ', keys %words;
=cut

while (<>) {
  for my $symb ( split //, $_ ) {
    ++$sc;
    for my $ccp ( keys %{ $config{'trans'} } ) {
      #next if grep $ccp eq $_, @dep;
      my $ts = cp_trans( 'cp1251', $ccp, $symb );
      if ( $ts =~ /[$config{'trans'}{$ccp}]/ ) { ++$s{$ccp}{$_} for split //, $ts; }
    }
  }
}
my ($ret);
print "# cp detect with cp_learn_symbols=$config{'cp_learn_symbols'}; from $sc bytes text\n";
for my $ccp ( keys %{ $config{'trans'} } ) {
  #next if grep $ccp eq $_, @dep;
  $ret{$ccp} = "  \$config{'trans_detect'}{'$ccp'}\t= '";
  my ( $i, $tmp, $tmp2, $tmp3 );
  for ( sort { $s{$ccp}{$b} <=> $s{$ccp}{$a} } keys %{ $s{$ccp} } ) {
    last if ++$i > $config{'cp_learn_symbols'};
    $ret{$ccp} .= sprintf( "\\x%X", ord($_) );
    $tmp .= $_;
    $tmp2 .= cp_trans( $ccp, $config{'cp_learn_print_cp'}, $_ );
    $tmp3 .= scalar cp_trans( $ccp, $config{'cp_learn_print_cp'}, $_ . '[' . sprintf( "%X", ord($_) ) . "]=$s{$ccp}{$_}; " );
  }
  $ret{$ccp} .= "';\t#  [$tmp] = [$tmp2];\tstat:$tmp3\n";
  print $ret{$ccp};
}
